%define dist_version 2_6_0
%define jaxp_altlevel 120

Name: xerces-j
Version: 2.6.0
Release: alt3.1

%def_enable tools

%define javadir		%_datadir/java
%define javadocdir	%_datadir/javadoc
%define pkgdocdir	%_docdir/%name-%version

Summary: Java XML parser
Group: System/Libraries
License: Apache
Url: http://xml.apache.org/xerces2-j/

Provides: jaxp_parser_impl = 1.2
Requires: xml-commons-apis

Source0: http://xml.apache.org/dist/xerces-j/Xerces-J-src.%version.tar.bz2
%if_enabled tools
Source1: http://xml.apache.org/dist/xerces-j/Xerces-J-tools.%version.tar.bz2
%endif

Patch0: %name-build.sh.patch
Patch1: %name-build.xml.patch

BuildArch: noarch

# Temporarily hardcode the JDK due to a chroot bug in Sun 1.4 JDK
BuildRequires: j2se1.3-sun-devel
#BuildRequires: j2se-devel
BuildRequires: libalternatives-devel
BuildRequires: xml-commons-apis
BuildRequires: xvfb-run

%description
Xerces2 is the next generation of high performance, fully compliant
XML parsers in the Apache Xerces family. This new version of Xerces
introduces the Xerces Native Interface (XNI), a complete framework for
building parser components and configurations that is extremely
modular and easy to program.  The Apache Xerces2 parser is the
reference implementation of XNI but other parser components,
configurations, and parsers can be written using the Xerces Native
Interface. For complete design and implementation documents, refer to
the XNI Manual.  Xerces 2 is a fully conforming XML Schema
processor. For more information, refer to the XML Schema page.  Xerces
2 also provides a partial implementation of Document Object Model
Level 3 Core, Load and Save and Abstract Schemas [deprecated] Working
Drafts.  For more information, refer to the DOM Level 3 Implementation
page.

%package manual
Summary: Manual for %name
Group: Development/Java
Requires: %name-javadoc = %version-%release

%description manual
Documentation for Xerces, a Java XML parser.

%package javadoc
Summary: Javadoc for %name
Group: Development/Java
Requires: xml-commons-apis-javadoc
AutoReqProv: no

%description javadoc
Javadoc for Xerces, a Java XML parser.

%package demo
Summary: Demo for %name
Group: Development/Java
Requires: %name = %version-%release

%description demo
Demonstrations and samples for Xerces, a Java XML parser.

%prep
%setup -q -n xerces-%dist_version
%if_enabled tools
%setup -q -n xerces-%dist_version -T -D -a 1
%endif
%patch0
%patch1

%__rm tools/xml-apis.jar
%__ln_s %javadir/xml-commons-apis.jar tools/xml-apis.jar

%build

%if_enabled tools
xvfb-run sh build.sh jars javadocs docs
%else	# enabled tools
xvfb-run ant \
    -Dbuild.compiler=modern \
    -Dtools.dir=%{javadir} \
    -Djar.apis=xml-commons-apis.jar \
    jars javadocs docs
%endif	# enabled tools

%install
# jars
install -d -m755 $RPM_BUILD_ROOT%javadir
install -m644 build/xercesImpl.jar $RPM_BUILD_ROOT%javadir/%name.jar
# manual
install -d -m755 $RPM_BUILD_ROOT%pkgdocdir
cp -a build/docs/* $RPM_BUILD_ROOT%pkgdocdir
# boilerplate docs
install -p -m644 LICENSE ISSUES STATUS TODO $RPM_BUILD_ROOT%pkgdocdir/
# javadoc
mkdir -p $RPM_BUILD_ROOT%javadocdir
mv -f $RPM_BUILD_ROOT%pkgdocdir/javadocs $RPM_BUILD_ROOT%javadocdir/%name
ln -s $(relative %javadocdir/%name %pkgdocdir/) \
    $RPM_BUILD_ROOT%pkgdocdir/javadocs
rm -rf $RPM_BUILD_ROOT%javadocdir/%name/api
ln -s ../xml-commons-apis $RPM_BUILD_ROOT%javadocdir/%name/api
# demo
install -d -m755 $RPM_BUILD_ROOT%_datadir/%name
install -p -m644 build/xercesSamples.jar $RPM_BUILD_ROOT%_datadir/%name/%name-samples.jar
cp -a data $RPM_BUILD_ROOT%_datadir/%name

mkdir -p $RPM_BUILD_ROOT%_altdir
cat <<EOF >$RPM_BUILD_ROOT%_altdir/%name
<group name="candidate">
    <option name="link">%javadir/jaxp_parser_impl.jar</option>
    <option name="real">%javadir/%name.jar</option>
    <option name="weight" type="number">%jaxp_altlevel</option>
</group>
EOF

%post
%register_alternatives %name -- jaxp_parser_impl

%preun
%unregister_alternatives %name

%files
%dir %pkgdocdir
%pkgdocdir/LICENSE
%pkgdocdir/ISSUES
%pkgdocdir/STATUS
%pkgdocdir/TODO
%javadir/*
%_altdir/%name

%files manual
%dir %pkgdocdir
%pkgdocdir/[a-z]*

%files javadoc
%javadocdir/*

%files demo
%_datadir/%name

%changelog
* Wed Jan 21 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt3.1
- Temporarily hardcode the JDK

* Sat Dec 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt3
- Patches from Alexey Borovskoy
- Use xvfb-run to start fake X server
- Migration to new alternatives scheme

* Sat Dec 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt2
- Added update-alternatives to install-time dependencies
- Corrected timing of updating alternatives during uninstall/upgrade
- Set JAVA_HOME to the commonly known J2SE directory

* Thu Dec 11 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt1
- New upstream release

* Thu Sep 11 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.5.0-alt1
- Updated to 2.5.0, renamed to xerces-j because xerces 1.x is obsolete
- Dropped README from the docs as it contains nothing but build instructions
- Remove JAXP api docs from javadoc, link to xml-commons-apis instead

* Sun Nov 17 2002 Mikhail Zabaluev <mhz@altlinux.ru> 2.2.1-alt1
- Ported the package over from the JPackage project. Thank you guys.
